using System;
using System.Collections.Generic;

    public class BT_SET <BT_VALUE>
    {
        List<BT_VALUE> bset;
        Int32 capacity;

        public BT_SET(Int32 initialCapacity)
        {
            INITIALISATION(initialCapacity);
        }
        public void INITIALISATION(Int32 initialCapacity)
        {
            bset = new List<BT_VALUE>(initialCapacity);
            capacity = initialCapacity;
        }
        public Int32 cardinal()
        {
            return (bset.Count);
        }
        public Int32 isFull()
        {
            if (bset.Count == capacity)
            {
                return 1;
            }
            else
            {
                return 0;
            }
        }
        public Boolean isIn(BT_VALUE vv)
        {
            return bset.Contains(vv);
        }
        public void remove(BT_VALUE vv)
        {
            bset.Remove(vv);
        }
        public void add(BT_VALUE vv)
        {
            bset.Add(vv);
        }
        public void clear()
        {
            bset.Clear();
        }
        public String text()
        {
            String text = "";
            bset.ForEach(delegate(BT_VALUE element) { text = text + " " + element.ToString(); }
                );
            return text;
        } 
    }