using System;
using System.Collections.Generic;

    public class BT_SEQUENCE<BT_VALUE>
    {
        LinkedList<Int32> bseq;
        Int32 capacity;

        public BT_SEQUENCE(Int32 initialCapacity)
        {
            INITIALISATION(initialCapacity);
        }

        public void INITIALISATION(Int32 initialCapacity)
        {
            bseq = new LinkedList<Int32>();
            capacity = initialCapacity;
        }

        public Int32 numberOfElements()
        {
            return (bseq.Count);
        }

        public Int32 isFull()
        {
            if (bseq.Count == capacity)
            {
                return 1;
            }
            else
            {
                return 0;
            }
        }

        public int get(Int32 ii)
        {
            Int32[] sequence = new Int32[bseq.Count];
            bseq.CopyTo(sequence, 0);
            return sequence[ii - 1];
        }

        public Int32 getFirst()
        {
            return bseq.First.Value;
            ;
        }

        public int getLast()
        {
            return bseq.Last.Value;
        }

        public void removeFirst()
        {
            bseq.RemoveFirst();
        }

        public void removeLast()
        {
            bseq.RemoveLast();
        }

        public void remove(Int32 ii)
        {
               LinkedListNode<Int32> node = bseq.First;
               for (Int32 count = 1; count < ii; count++)
               {
                   node = node.Next;
               }
                   bseq.Remove(node);
        }

        public void addFirst(Int32 vv)
        {
            LinkedListNode<Int32> node = new LinkedListNode<Int32>(vv);
            bseq.AddFirst(node);
        }

        public void addLast(Int32 vv)
        {
            LinkedListNode<Int32> node = new LinkedListNode<Int32>(vv);
            bseq.AddLast(node);
        }

        public void add(Int32 ii, Int32 vv)
        {
            
            LinkedList<Int32> expanded_bseq = new LinkedList<int>();
            for (Int32 count = 1; count < ii; count++)
            {
                expanded_bseq.AddLast(get(count));
            }
            expanded_bseq.AddLast(vv);
            for (Int32 count = ii; count < (bseq.Count + 1); count++)
            {
                expanded_bseq.AddLast(get(count));
            }
            bseq = expanded_bseq;
        }

        public void set(int ii, int vv)
        {
            LinkedListNode<Int32> node = bseq.First;
            for (Int32 count = 1; count < ii; count++)
            {
                node = node.Next;
            }
            node.Value = vv;
        }

        public void clear()
        {
            bseq.Clear();
        }

        public String text()
        {
            String text = "";

            foreach (Int32 node in bseq)
            {
                text = text + " " + node;
            }

            return text;
        }

    }